function iSample=searchy(y,yVal,iStart=1)

# iSample = searchy(y, yVal, iStart)
#
# Returns the sample index for y that corresponds to its y-value yVal given. 
# 
# If Waveform doesn't reach the level of yVal at any point, iSample = 0.
# 
# The optional parameter iStart can be provided to specify a sample index from
# which to begin the search for yVal. Otherwise, the search starts from the 
# first sample.
  
# Author:
#   Lukasz Starzak 
#   Dept. of Microelectronics and Computer Science, Lodz University of Technology

  nSamples = length(y);
  iSample = iStart;
  if (y(iStart) < yVal)
    while ((iSample <= nSamples) && (y(iSample) < yVal))
      iSample++;
    endwhile
  elseif (y(iStart) > yVal)
    while ((iSample <= nSamples) && (y(iSample) > yVal))
      iSample++;
    endwhile
  endif
  if (iSample <= nSamples)
    if (iSample > iStart && abs(y(iSample-1)-yVal) < abs(y(iSample)-yVal))
      iSample--;
    endif
  else
    iSample = 0;
  endif
endfunction
